#property copyright "alx"

extern double Lots               = 0.1;
extern double MaximumRisk        = 0.02;
extern double DecreaseFactor     = 3;
extern int MagicNumber = 1;
extern bool SignalMail = False;
extern bool EachTickMode = False;
extern int Slippage = 2;
extern bool StopLossMode = True;
extern int StopLoss = 12;
extern bool TakeProfitMode = False;
extern int TakeProfit = 15;
extern bool TrailingStopMode = False;
extern int TrailingStop = 30;
extern int MaxOrders = 3;

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

int BarCount;
int Current;
bool TickCheck = False;

//lot size  
                                     
double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   lot=NormalizeDouble(AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calc number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<0.1) lot=0.1;
   return(lot);
  }
  

// initialization                                  

int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}

//deinitialization   
                              
int deinit() {
   return(0);
}

// expert start    

int start() {
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;



   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;
  

// Variable                                                 

      double Buy1_1 = iCustom(NULL, PERIOD_M5, "trv", 0, Current + 0);
      double Buy1_2 = 0;
      double Buy2_1 = iCustom(NULL, PERIOD_M15, "trv", 0, Current + 0);
      double Buy2_2 = 0;
      double Buy3_1 = iCustom(NULL, PERIOD_M30, "trv", 0, Current + 0);
      double Buy3_2 = 0;
      double Buy4_1 = iCustom(NULL, PERIOD_H1, "trv", 0, Current + 0);
      double Buy4_2 = 0;
      double Buy5_1 = iCustom(NULL, PERIOD_H4, "trv", 0, Current + 0);
      double Buy5_2 = 0;
      double Buy6_1 = iMACD(NULL, 0, 12, 26, 9, PRICE_CLOSE, MODE_SIGNAL, Current + 1);
      double Buy6_2 = iMACD(NULL, 0, 12, 26, 9, PRICE_CLOSE, MODE_SIGNAL, Current + 0);
      double Sell1_1 = iCustom(NULL, PERIOD_M5, "trv", 0, Current + 0);
      double Sell1_2 = 1;
      double Sell2_1 = iCustom(NULL, PERIOD_M15, "trv", 0, Current + 0);
      double Sell2_2 = 1;
      double Sell3_1 = iCustom(NULL, PERIOD_M30, "trv", 0, Current + 0);
      double Sell3_2 = 1;
      double Sell4_1 = iCustom(NULL, PERIOD_H1, "trv", 0, Current + 0);
      double Sell4_2 = 1;
      double Sell5_1 = iCustom(NULL, PERIOD_H4, "trv", 0, Current + 0);
      double Sell5_2 = 1;
      double Sell6_1 = iMACD(NULL, 0, 12, 26, 9, PRICE_CLOSE, MODE_SIGNAL, Current + 1);
      double Sell6_2 = iMACD(NULL, 0, 12, 26, 9, PRICE_CLOSE, MODE_SIGNAL, Current + 0);
      double CloseBuy1_1 = iCustom(NULL, PERIOD_M5, "trv", 0, Current + 0);
      double CloseBuy1_2 = 1;
      double CloseBuy2_1 = iCustom(NULL, PERIOD_M15, "trv", 0, Current + 0);
      double CloseBuy2_2 = 1;
      double CloseSell1_1 = iCustom(NULL, PERIOD_M5, "trv", 0, Current + 0);
      double CloseSell1_2 = 0;
      double CloseSell2_1 = iCustom(NULL, PERIOD_M15, "trv", 0, Current + 0);
      double CloseSell2_2 = 0;


// Variable End                                                     

   //Check position
   bool IsTrade = False;

   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         IsTrade = True;
         if(OrderType() == OP_BUY) {
            //Close


//Exit Buy                                          


               if (CloseBuy1_1 == CloseBuy1_2 && CloseBuy2_1 == CloseBuy2_2) Order = SIGNAL_CLOSEBUY;


// Signal End Exit Buy                                            


            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         } else {
            //Close


//Exit Sell


               if (CloseSell1_1 == CloseSell1_2 && CloseSell2_1 == CloseSell2_2) Order = SIGNAL_CLOSESELL;

// Signal End Exit Sell


            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
               if (!EachTickMode) BarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     continue;
                  }
               }
            }
         }
      }
   }


//Entry

      if (Buy1_1 == Buy1_2 && Buy2_1 == Buy2_2 && Buy3_1 == Buy3_2 && Buy4_1 == Buy4_2 && Buy5_1 == Buy5_2) Order = SIGNAL_BUY;
      if (Sell1_1 == Sell1_2 && Sell2_1 == Sell2_2 && Sell3_1 == Sell3_2 && Sell4_1 == Sell4_2 && Sell5_1 == Sell5_2) Order = SIGNAL_SELL;

// Signal End                                                       |
   
int MinutesToNextTrade = 15;
int orders=HistoryTotal(); 
OrderSelect(orders-1,SELECT_BY_POS,MODE_HISTORY);
if (OrderProfit()<0 && CurTime()-OrderOpenTime()<MinutesToNextTrade*60) return(0);

   
   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(ScanTrades() < MaxOrders) {
             //Check free margin
         if (AccountFreeMargin() < (500 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (StopLossMode) StopLossLevel = Ask - StopLoss * Point; else StopLossLevel = 0.0;
         if (TakeProfitMode) TakeProfitLevel = Ask + TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_BUY, LotsOptimized(), Ask, Slippage, StopLossLevel, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("BUY order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			} else {
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(ScanTrades() < MaxOrders) {
         //Check free margin
         if (AccountFreeMargin() < (500 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (StopLossMode) StopLossLevel = Bid + StopLoss * Point; else StopLossLevel = 0.0;
         if (TakeProfitMode) TakeProfitLevel = Bid - TakeProfit * Point; else TakeProfitLevel = 0.0;

         Ticket = OrderSend(Symbol(), OP_SELL, LotsOptimized(), Bid, Slippage, StopLossLevel, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) {
				Print("SELL order opened : ", OrderOpenPrice());
                if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
			} else {
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   if (!EachTickMode) BarCount = Bars;

   return(0);
}

int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == MagicNumber) 
   numords++;
   }
   return(numords);
}